#ifndef _INCLUDE_GUARD_PD6729_H_
#define _INCLUDE_GUARD_PD6729_H_

#include <linux/interrupt.h>


/* Debuging defines */
#ifdef NOTRACE
#define enter(x)   printk("Enter: %s, %s line %i\n",x,__FILE__,__LINE__)
#define leave(x)   printk("Leave: %s, %s line %i\n",x,__FILE__,__LINE__)
#define dprintk(fmt, args...) printk(fmt , ## args)
#else
#define enter(x)   do {} while (0)
#define leave(x)   do {} while (0)
#define dprintk(fmt, args...) do {} while (0)
#endif


/* Flags for I365_GENCTL */
#define I365_DF_VS1		0x40	/* DF-step Voltage Sense */
#define I365_DF_VS2		0x80

/* Fields in PD67_EXTERN_DATA */
#define PD67_EXD_VS1(s)		(0x01 << ((s)<<1))
#define PD67_EXD_VS2(s)		(0x02 << ((s)<<1))

/* prototypes */

static int  pd6729_pci_probe(struct pci_dev *dev, const struct pci_device_id *id);
static void pd6729_pci_remove(struct pci_dev *dev);
static int card_present(int socketno);
static irqreturn_t pd6729_interrupt(int irq, void *dev, struct pt_regs *regs);
static int pd6729_get_status(struct pcmcia_socket *socket, u_int *value);
static int pd6729_get_socket(struct pcmcia_socket *socket, socket_state_t *state);
static int pd6729_set_socket(struct pcmcia_socket *socket, socket_state_t *state);
static int pd6729_set_io_map(struct pcmcia_socket *socket, struct pccard_io_map *io);
static int pd6729_set_mem_map(struct pcmcia_socket *socket, struct pccard_mem_map *mem);
static int pd6729_init(struct pcmcia_socket *socket);
static int pd6729_suspend(struct pcmcia_socket *socket);

#endif

